//-------------------------------------------------------------------------
// QFLW400.H
// modified 13.01.00
//-------------------------------------------------------------------------
// This is the header to use QFLW400.DLL functions with VC++ 4.2
// To use the DLL, add the static import library QFLW400.LIB to the project
//-------------------------------------------------------------------------
// Physik Instrumente (PI)
//-------------------------------------------------------------------------

#define BYTE unsigned char

#ifdef __cplusplus
    extern "C" {
#endif

// definitions:
#define CMD_NOPARA	1

#define RD_NOFRAC	2
#define RD_U1616	4
#define RD_S1616	5
#define RD_U0032	6

#define WR_NOFRAC	12
#define WR_U1616	14
#define WR_S1616	15
#define WR_U0032	16
#define EXDEF		20

typedef struct TCMD{
           BYTE code;
           BYTE cmd_group;
           char lab[6];
}TCMD;


// Function Prototypes:

short __stdcall Board_Installed(void);   
long  __stdcall get_pos(BYTE axis); 
long  __stdcall get_PosErr(BYTE axis);   
int   __stdcall get_stat(BYTE axis);  
void  __stdcall translate(char *comstr, char *report);
void  __stdcall execute(BYTE axis, TCMD command, long para, char *report);
BOOL  __stdcall moving(BYTE axis);
BYTE  __stdcall Axis_Installed(void); 
void  __stdcall Set_BaseAddress(unsigned short address); 
int   __stdcall InitBoard(BYTE mode);
void  __stdcall InitAxis(BYTE axis); 
void  __stdcall MoveA(BYTE axis, long nPosition );   
void  __stdcall MoveR(BYTE axis, long nCounts );     
int   __stdcall autodetect(void);

#ifdef __cplusplus 
}
#endif

// Definition of Commands for execute function
TCMD
	UP ={0x1A, CMD_NOPARA,  "UP:" },
	TP ={0x37, RD_NOFRAC,   "TP:" },
	GLS={0x67, RD_NOFRAC,   "GLS:"},
	TT ={0x4A, RD_NOFRAC,   "TT:" },
	MUP={0x5B, WR_NOFRAC,   "MUP:"},
	TS ={0x31, RD_NOFRAC,	"TS:" },
	GIP={0x36, RD_NOFRAC,	"GIP:"},
	MA ={0x10, EXDEF,		"MA:" },
	SV ={0x11, WR_U1616,	"SV:" };

