// File : QFLW500_CVI.h 
// Date : 2002-03-01

#include <cvidef.h>  

#ifdef __cplusplus
    extern "C" {
#endif

// This is the header to use QFLW500.DLL functions with CVI

// To use the DLL, include the static import
// library QFLW500_CVI.LIB into the project


// definitions:
#define CMD_NOPARA	1

#define RD_NOFRAC	2
#define RD_U1616	4
#define RD_S1616	5
#define RD_U0032	6

#define WR_NOFRAC	12
#define WR_U1616	14
#define WR_S1616	15
#define WR_U0032	16
#define EXDEF		20


// types & structures:
typedef unsigned char BYTE;
typedef unsigned int  WORD;

typedef struct struct_CMD{
           BYTE code;
           BYTE cmd_group;
           char lab[6];
}TCMD;

typedef struct struct_Q_long{
           long nPosition[4];
}TQ_long;


// function prototypes :

long  __stdcall get_pos(BYTE axis); 
long  __stdcall get_PosErr(BYTE axis);
long  __stdcall get_v(BYTE axis);
int   __stdcall get_stat(BYTE axis);  
void  __stdcall get_pos4(TQ_long *pos4);
WORD  __stdcall get_BoardStatus(void);
BYTE  __stdcall get_DIN(void);
int   __stdcall get_ErrorStatus(void);  
int   __stdcall get_Limit(void);
int   __stdcall get_LimitAxis(BYTE axis);  
WORD  __stdcall get_RefSignal(BYTE axis);  

void  __stdcall execute(BYTE axis, TCMD command, long para, char *report);
void  __stdcall translate(char *comstr, char *report);  
BOOL  __stdcall moving(BYTE axis);
void  __stdcall Set_BaseAddress(unsigned short address); 
BYTE  __stdcall Axis_Installed(void); 
int   __stdcall InitBoard(BYTE mode);
void  __stdcall InitAxis(BYTE axis); 
void  __stdcall InitStage(BYTE axis, BYTE stagetype); 
BOOL  __stdcall Board_Installed(void);   
void  __stdcall MoveA(BYTE axis, long nPosition );   
void  __stdcall MoveR(BYTE axis, long nCounts );     
void  __stdcall VectorA(BYTE axis1, BYTE axis2, long p1, long p2, long vv, long va);
void  __stdcall VectorR(BYTE axis1, BYTE axis2, long inc1, long inc2, long vv, long va);
int   __stdcall WaitStop(BYTE axis);
void  __stdcall Init_LS(BYTE axis1, BYTE axis2, BYTE axis3, BYTE axis4);
//WORD  __stdcall StatusBoard(void);
void  __stdcall axis_select(BYTE axis);
void  __stdcall setQMC(BYTE command, long parameter);
long  __stdcall getQMC(BYTE command);
int   __stdcall autodetect(void);
void  __stdcall set_pos(BYTE axis, long newpos);
int   __stdcall set_Amplifier(BYTE mode);
void  __stdcall set_DOUT(BYTE digout);
void  __stdcall set_acc(BYTE axis, int acceleration);
void  __stdcall set_pid(BYTE axis, int pterm, int iterm, int dterm);
void  __stdcall set_vel(BYTE axis, int velocity);

void  __stdcall AutoFindEdge(BYTE axis, BYTE mode);

void  __stdcall MoveA_12(long pos_1, long pos_2);
void  __stdcall MoveA_123(long pos_1, long pos_2, long pos_3);
void  __stdcall MoveR_12(long shift_1, long shift_2);
void  __stdcall MoveR_123(long shift_1, long shift_2, long shift_3);


// Definition of Commands for execute function
TCMD
	UP ={0x1A, CMD_NOPARA,  "UP:" },
	TP ={0x37, RD_NOFRAC,   "TP:" },
	GLS={0x67, RD_NOFRAC,   "GLS:"},
	TT ={0x4A, RD_NOFRAC,   "TT:" },
	TS ={0x31, RD_NOFRAC,	"TS:" },
	GIP={0x36, RD_NOFRAC,	"GIP:"},
	MA ={0x10, EXDEF,		"MA:" },
	SV ={0x11, WR_U1616,	"SV:" },
	GMO={0x49, RD_NOFRAC,	"GMO:"},
	MR ={0xE1, EXDEF,		"MR:" },
//10
	GH ={0xE2, EXDEF,		"GH:" },
	TX ={0x36, RD_NOFRAC,	"TX:" },
	WS ={0xE3, EXDEF,		"WS:" },
	MN ={0x43, CMD_NOPARA,	"MN:" },
	MF ={0x42, CMD_NOPARA,	"MF:" },
	TV ={0xE4, EXDEF,		"TV:" },
	CLR={0x33, CMD_NOPARA,	"CLR:"},
	ST ={0xE5, EXDEF,		"ST:" },
	SA ={0x12, WR_U1616,	"SA:" },
	DH ={0x3F, CMD_NOPARA,	"DH:" },
//20
	TY ={0x4B, RD_U1616,	"TY:" },
	GPP={0x1D, RD_NOFRAC,	"GPP:"},
	GPV={0x1E, RD_S1616,	"GPV:"},
	TF ={0x60, RD_NOFRAC,	"TF:" },
	RT ={0x39, CMD_NOPARA,	"RT:" },
	GB ={0x57, RD_NOFRAC,	"GB:" },
	GIR={0x30, RD_NOFRAC,	"GIR:"},
	SAN={0x5C, CMD_NOPARA,	"SAN:"},
	SAF={0x5D, CMD_NOPARA,	"SAF:"},
	TL ={0x4C, RD_U1616,	"TL:" },
//30
	ASN={0x45, CMD_NOPARA,	"ASN:"},
	ASF={0x44, CMD_NOPARA,	"ASF:"},
	SMO={0x62, WR_NOFRAC,	"SMO:"},
	TE ={0xE6, EXDEF,		"TE:" },
	SFP={0x21, CMD_NOPARA,	"SFP:"},
	SFV={0x22, CMD_NOPARA,	"SFV:"},
	DP ={0x25, WR_NOFRAC,	"DP:" },
	DD ={0x27, WR_NOFRAC,	"DD:" },
	DI ={0x26, WR_NOFRAC,	"DI:" },
	DF ={0x2B, WR_NOFRAC,	"DF:" },
//40
	DL ={0x28, WR_NOFRAC,	"DL:" },
	GP ={0x50, RD_NOFRAC,	"GP:" },
	GD ={0x52, RD_NOFRAC,	"GD:" },
	GI ={0x51, RD_NOFRAC,	"GI:" },
	GF ={0x54, RD_NOFRAC,	"GF:" },
	GL ={0x53, RD_NOFRAC,	"GL:" },
	GPE={0x55, RD_NOFRAC,	"GPE:"},
	GSI={0x2E, RD_NOFRAC,	"GSI:"},
	RTI={0x32, WR_NOFRAC,	"RTI:"},
	GIM={0x56, RD_NOFRAC,	"GIM:"},
//50
	TG ={0xE7, EXDEF,		"TG:" },
	SCI={0x64, CMD_NOPARA,	"SCI:"},
	LE ={0x70, CMD_NOPARA,	"LE: "},
	LD ={0x71, CMD_NOPARA,	"LD: "},
	SPS={0x0B, CMD_NOPARA,	"SPS:"},
	SPT={0x09, CMD_NOPARA,	"SPT:"},
	SMA={0x15, WR_NOFRAC,	"SMA:"},
	GMA={0x4F, RD_NOFRAC,	"GMA:"},
	STP={0x46, EXDEF,	"STP:"},
	SYN={0x47, CMD_NOPARA,	"SYN:"},
//60
	SPE={0x29, WR_NOFRAC,	"SPE:"},
	SCH={0x65, CMD_NOPARA,	"SCH:"},
	SLS={0x66, WR_NOFRAC,	"SLS:"},
	VE ={0x6C, RD_NOFRAC,	"VE: "},
	GTI={0x3E, RD_NOFRAC,	"GTI:"},
	WA ={0xE8, EXDEF,		"WA: "},
	SBT={0x17, CMD_NOPARA,	"SBT:"},
	SBP={0x18, CMD_NOPARA,	"SBP:"},
	SBN={0x19, CMD_NOPARA,	"SBN:"},
	SBA={0x1B, CMD_NOPARA,	"SBA:"},
//70
	SBC={0x1C, CMD_NOPARA,	"SBC:"},
	SBF={0x6D, CMD_NOPARA,	"SBF:"},
	SB ={0x16, WR_NOFRAC,	"SB:" },
	SIM={0x2F, WR_NOFRAC,	"SIM:"},
	GJ ={0x58, RD_U0032,	"GJ:" },
	SJ ={0x13, WR_U0032,	"SJ:" },
	SRA={0x14, WR_S1616,	"SRA:"},
	GRA={0x59, RD_S1616,	"GRA:"},
	SPV={0x0A, CMD_NOPARA,	"SPV:"},
	SPG={0x0C, CMD_NOPARA,	"SPG:"},
//80
	SL ={0xE9, EXDEF,		"SL: "},
	AN ={0x41, CMD_NOPARA,	"AN: "},
	AF ={0x40, CMD_NOPARA,	"AF: "},
	SOP={0x3C, CMD_NOPARA,	"SOP:"},
	SOH={0x3B, CMD_NOPARA,	"SOH:"},
	SST={0x38, WR_NOFRAC,	"SST:"},
	GT ={0x61, RD_NOFRAC,	"GT: "},
	GOM={0x6E, RD_NOFRAC,	"GOM:"},
	SAP={0x4D, WR_NOFRAC,	"SAP:"},
	TZ ={0xEA, EXDEF,	"TZ: "},
//90
	TC ={0xEB, EXDEF,	"TC: "},
	CN ={0xEC, EXDEF,	"CN: "},
	CF ={0xED, EXDEF,	"CF: "},
	IV ={0xEE, EXDEF,	"IV: "},
	AB ={0xEF, EXDEF,	"AB: "},
	WC ={0xF0, EXDEF,	"WC: "},
	WT ={0xF1, EXDEF,	"WT: "},
	FEP={0xF2, EXDEF,	"DEP:"},
	FEN={0xF3, EXDEF,	"FEN:"},
	BN ={0xF4, EXDEF,	"BN:"},
//100
	BF ={0xF5, EXDEF,	"BF:"},
	RET={0xF6, EXDEF,	"FEN:"},
	SIL={0xF7, EXDEF,	"SIL:"};


#ifdef __cplusplus 
}
#endif



