#include <windows.h>
#include <QFL5_CVI.h>

/* The two macros below are used as error return codes */
/* in case the DLL does not load, or is missing one or */
/* more functions, respectively.  You must define them */
/* to whatever values are meaningful for your DLL.     */
#define kFailedToLoadDLLError     ???
#define kCouldNotFindFunction     ???

static HINSTANCE DLLHandle;

/* Declare the variables that hold the addresses of the function   */
/* pointers.                                                       */
static long (__stdcall *get_pos_Ptr)(char cAxis);
static long (__stdcall *get_PosErr_Ptr)(char cAxis);
static int (__stdcall *get_stat_Ptr)(char cAxis);
static void (__stdcall *get_pos4_Ptr)(TQ_long *pos4);
static void (__stdcall *execute_Ptr)(char axis, TCMD command, long para,
                                     char *report);
static void (__stdcall *translate_Ptr)(char *comstr, char *report);
static BYTE (__stdcall *moving_Ptr)(BYTE axis);
static void (__stdcall *Set_BaseAddress_Ptr)(unsigned short address);
static BYTE (__stdcall *Axis_Installed_Ptr)(void);
static int (__stdcall *InitBoard_Ptr)(BYTE mode);
static void (__stdcall *InitAxis_Ptr)(BYTE axis);
static short (__stdcall *Board_Installed_Ptr)(void);
static void (__stdcall *MoveA_Ptr)(char cAxis, long nPosition);
static void (__stdcall *MoveR_Ptr)(char cAxis, long nCounts);
static int (__stdcall *WaitStop_Ptr)(char cAxis);
static void (__stdcall *Init_LS_Ptr)(char cAxis1, char cAxis2, char cAxis3,
                                     char cAxis4);
static WORD (__stdcall *StatusBoard_Ptr)(void);
static int (__stdcall *autodetect_Ptr)(void);
static void (__stdcall *VectorA_12_Ptr)(long v_path, long pos_1,
                                        long pos_2);
static void (__stdcall *VectorR_12_Ptr)(long v_path, long shift_1,
                                        long shift_2);
static void (__stdcall *MoveA_12_Ptr)(long pos_1, long pos_2);
static void (__stdcall *MoveA_123_Ptr)(long pos_1, long pos_2, long pos_3);
static void (__stdcall *MoveR_12_Ptr)(long shift_1, long shift_2);
static void (__stdcall *MoveR_123_Ptr)(long shift_1, long shift_2,
                                       long shift_3);


/* Load the DLL and get the addresses of the functions */
static int LoadDLLIfNeeded(void)
{
    if (DLLHandle)
        return 0;

    DLLHandle = LoadLibrary("QFLW32F.dll");
    if (DLLHandle == NULL) {
        return kFailedToLoadDLLError;
        }

    if (!(get_pos_Ptr = (void*) GetProcAddress(DLLHandle, "get_pos")))
        goto FunctionNotFoundError;

    if (!(get_PosErr_Ptr = (void*) GetProcAddress(DLLHandle, "get_PosErr")))
        goto FunctionNotFoundError;

    if (!(get_stat_Ptr = (void*) GetProcAddress(DLLHandle, "get_stat")))
        goto FunctionNotFoundError;

    if (!(get_pos4_Ptr = (void*) GetProcAddress(DLLHandle, "get_pos4")))
        goto FunctionNotFoundError;

    if (!(execute_Ptr = (void*) GetProcAddress(DLLHandle, "execute")))
        goto FunctionNotFoundError;

    if (!(translate_Ptr = (void*) GetProcAddress(DLLHandle, "translate")))
        goto FunctionNotFoundError;

    if (!(moving_Ptr = (void*) GetProcAddress(DLLHandle, "moving")))
        goto FunctionNotFoundError;

    if (!(Set_BaseAddress_Ptr = (void*) GetProcAddress(DLLHandle, 
         "Set_BaseAddress")))
        goto FunctionNotFoundError;

    if (!(Axis_Installed_Ptr = (void*) GetProcAddress(DLLHandle, 
         "Axis_Installed")))
        goto FunctionNotFoundError;

    if (!(InitBoard_Ptr = (void*) GetProcAddress(DLLHandle, "InitBoard")))
        goto FunctionNotFoundError;

    if (!(InitAxis_Ptr = (void*) GetProcAddress(DLLHandle, "InitAxis")))
        goto FunctionNotFoundError;

    if (!(Board_Installed_Ptr = (void*) GetProcAddress(DLLHandle, 
         "Board_Installed")))
        goto FunctionNotFoundError;

    if (!(MoveA_Ptr = (void*) GetProcAddress(DLLHandle, "MoveA")))
        goto FunctionNotFoundError;

    if (!(MoveR_Ptr = (void*) GetProcAddress(DLLHandle, "MoveR")))
        goto FunctionNotFoundError;

    if (!(WaitStop_Ptr = (void*) GetProcAddress(DLLHandle, "WaitStop")))
        goto FunctionNotFoundError;

    if (!(Init_LS_Ptr = (void*) GetProcAddress(DLLHandle, "Init_LS")))
        goto FunctionNotFoundError;

    if (!(StatusBoard_Ptr = (void*) GetProcAddress(DLLHandle, "StatusBoard")))
        goto FunctionNotFoundError;

    if (!(autodetect_Ptr = (void*) GetProcAddress(DLLHandle, "autodetect")))
        goto FunctionNotFoundError;

    if (!(VectorA_12_Ptr = (void*) GetProcAddress(DLLHandle, "VectorA_12")))
        goto FunctionNotFoundError;

    if (!(VectorR_12_Ptr = (void*) GetProcAddress(DLLHandle, "VectorR_12")))
        goto FunctionNotFoundError;

    if (!(MoveA_12_Ptr = (void*) GetProcAddress(DLLHandle, "MoveA_12")))
        goto FunctionNotFoundError;

    if (!(MoveA_123_Ptr = (void*) GetProcAddress(DLLHandle, "MoveA_123")))
        goto FunctionNotFoundError;

    if (!(MoveR_12_Ptr = (void*) GetProcAddress(DLLHandle, "MoveR_12")))
        goto FunctionNotFoundError;

    if (!(MoveR_123_Ptr = (void*) GetProcAddress(DLLHandle, "MoveR_123")))
        goto FunctionNotFoundError;

    return 0;

FunctionNotFoundError:
    FreeLibrary(DLLHandle);
    DLLHandle = 0;
    return kCouldNotFindFunction;
}


/* Glue Code for each of the DLL functions */



long __stdcall get_pos(char cAxis)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*get_pos_Ptr)(cAxis);
}


long __stdcall get_PosErr(char cAxis)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*get_PosErr_Ptr)(cAxis);
}


int __stdcall get_stat(char cAxis)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*get_stat_Ptr)(cAxis);
}


void __stdcall get_pos4(TQ_long *pos4)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*get_pos4_Ptr)(pos4);
}


void __stdcall execute(char axis, TCMD command, long para, char *report)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*execute_Ptr)(axis, command, para, report);
}


void __stdcall translate(char *comstr, char *report)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*translate_Ptr)(comstr, report);
}


BYTE __stdcall moving(BYTE axis)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*moving_Ptr)(axis);
}


void __stdcall Set_BaseAddress(unsigned short address)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*Set_BaseAddress_Ptr)(address);
}


BYTE __stdcall Axis_Installed(void)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Axis_Installed_Ptr)();
}


int __stdcall InitBoard(BYTE mode)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*InitBoard_Ptr)(mode);
}


void __stdcall InitAxis(BYTE axis)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*InitAxis_Ptr)(axis);
}


short __stdcall Board_Installed(void)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Board_Installed_Ptr)();
}


void __stdcall MoveA(char cAxis, long nPosition)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*MoveA_Ptr)(cAxis, nPosition);
}


void __stdcall MoveR(char cAxis, long nCounts)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*MoveR_Ptr)(cAxis, nCounts);
}


int __stdcall WaitStop(char cAxis)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*WaitStop_Ptr)(cAxis);
}


void __stdcall Init_LS(char cAxis1, char cAxis2, char cAxis3, char cAxis4)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*Init_LS_Ptr)(cAxis1, cAxis2, cAxis3, cAxis4);
}


WORD __stdcall StatusBoard(void)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*StatusBoard_Ptr)();
}


int __stdcall autodetect(void)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*autodetect_Ptr)();
}


void __stdcall VectorA_12(long v_path, long pos_1, long pos_2)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*VectorA_12_Ptr)(v_path, pos_1, pos_2);
}


void __stdcall VectorR_12(long v_path, long shift_1, long shift_2)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*VectorR_12_Ptr)(v_path, shift_1, shift_2);
}


void __stdcall MoveA_12(long pos_1, long pos_2)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*MoveA_12_Ptr)(pos_1, pos_2);
}


void __stdcall MoveA_123(long pos_1, long pos_2, long pos_3)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*MoveA_123_Ptr)(pos_1, pos_2, pos_3);
}


void __stdcall MoveR_12(long shift_1, long shift_2)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*MoveR_12_Ptr)(shift_1, shift_2);
}


void __stdcall MoveR_123(long shift_1, long shift_2, long shift_3)
{
    int dllLoadError;

    if (dllLoadError = LoadDLLIfNeeded())
        return;
    (*MoveR_123_Ptr)(shift_1, shift_2, shift_3);
}

